; -----------------------------------------------------------------------------
; RetroForth for Linux       | This port was originally written by:
; http://www.retroforth.org  | * Tom Novelli *
; -----------------------------------------------------------------------------
macro section a { }
include "macros.fasm"

format elf executable
entry main

main:
	call init_retroforth
	call interpret
;---------------------------------------------------------------------
code 'emit', emit	
	push ebx,ecx,edx
	mov ebx, 1	;stdout
	mov edx, ebx	;count
	lea ecx, [esp-4]
	mov [ecx], eax
	mov eax, 4	;sys_write
	int 80h
	pop ebx,ecx,edx
	drop
	ret
code 'key', key
	dup
	push ebx,ecx,edx
	sub ebx,ebx	;0 = stdin
	mov edx, 1	;count
	lea ecx, [esp-4]
	mov eax, 3	;sys_read
	int 80h
	mov eax, [ecx]
	pop ebx,ecx,edx
	ret
;---------------------------------------------------------------------
code 'bye', linux_bye	
	sub ebx,ebx	;Return exit status 0
	mov eax,ebx
	inc eax		;1 = sys_exit
	int 80h
;---------------------------------------------------------------------
include "retroforth.asm"
